package gg.malloc.defense.commands;

import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

import gg.malloc.defense.engine.GameRunner;

import gg.malloc.defense.Plugin;

public class ListGamesCommand implements CommandExecutor {
  Plugin m_plugin;

  public ListGamesCommand(Plugin plugin) {
    m_plugin = plugin;
  }

  @Override
  public boolean onCommand(CommandSender sender, Command command, String s, String[] args) {
    sender.sendMessage("Available games:");
    for(String arenaName : m_plugin.arenaNames()) {
      String arenaDescription = arenaName + ": ";
      if (m_plugin.hasRunnerForArenaName(arenaName)) {
        GameRunner runner = m_plugin.getRunnerForArenaName(arenaName);
        arenaDescription += runner.getStage().toString();
      } else {
        arenaDescription += "Loadable";
      }
      sender.sendMessage(arenaDescription);
    }
    return true;
  }
}

