package gg.malloc.defense.engine;

import gg.malloc.defense.model.Spawner;
import gg.malloc.defense.model.Waypoint;
import gg.malloc.defense.model.Arena;

import org.bukkit.entity.Entity;
import org.bukkit.entity.LivingEntity;
import org.bukkit.entity.EntityType;
import org.bukkit.entity.Mob;
import org.bukkit.World;
import org.bukkit.Location;
import org.bukkit.inventory.EntityEquipment;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;
import org.bukkit.Material;
import org.bukkit.attribute.Attribute;
import org.bukkit.attribute.AttributeModifier;

public class GameSpawner implements Spawner {
  Arena m_arena;
  MobManager m_manager;
  PlayerManager m_players;
  int m_spawnIdx = 0;
  World m_world;

  public GameSpawner(World world, Arena arena, MobManager manager, PlayerManager players) {
    m_world = world;
    m_arena = arena;
    m_manager = manager;
    m_players = players;
  }

  @Override
  public LivingEntity spawnBombCarrier(EntityType type) {
    if (m_manager.bombCount() == 0) {
      return m_manager.addBombCarrier(spawnMob(type));
    } else {
      return spawnMob(type);
    }
  }

  @Override
  public LivingEntity spawnMob(EntityType type) {
    Waypoint[] spawnpoints = m_arena.spawnpoints();
    m_spawnIdx %= spawnpoints.length;
    //m_log.fine("Spawning " + type + " at " + spawnpoints[m_spawnIdx]);
    Waypoint thisSpawner = spawnpoints[m_spawnIdx];
    Location loc = new Location(m_world, thisSpawner.getX(), thisSpawner.getY(), thisSpawner.getZ());
    Entity newMob = m_world.spawnEntity(loc, type);
    LivingEntity livingMob = (LivingEntity)newMob;
    livingMob.setRemoveWhenFarAway(false);
    m_manager.addEntity(livingMob);
    m_spawnIdx += 1;
    return livingMob;
  }
}
